## axc 0.3.3

=== Makefile ===
### toolchain
#
CC ?= gcc
AR ?= ar
MKDIR = mkdir
MKDIR_P = mkdir -p
CMAKE ?= cmake
CMAKE_FLAGS = -DCMAKE_BUILD_TYPE=Debug -DCMAKE_C_FLAGS=-fPIC

PKG_CONFIG ?= pkg-config
GLIB_CFLAGS ?= $(shell $(PKG_CONFIG) --cflags glib-2.0)
GLIB_LDFLAGS ?= $(shell $(PKG_CONFIG) --libs glib-2.0)

SQLITE3_CFLAGS ?= $(shell $(PKG_CONFIG) --cflags sqlite3)
SQLITE3_LDFLAGS ?= $(shell $(PKG_CONFIG) --libs sqlite3)

LIBGCRYPT_CONFIG ?= libgcrypt-config
LIBGCRYPT_LDFLAGS ?= $(shell $(LIBGCRYPT_CONFIG) --libs)

SDIR = src
LDIR = lib
BDIR = build
TDIR = test
TFN = test_all
CDIR = coverage

AX_DIR=./lib/libsignal-protocol-c
AX_BDIR=$(AX_DIR)/build/src
AX_PATH=$(AX_BDIR)/libsignal-protocol-c.a

PKGCFG_C=$(GLIB_CFLAGS) \
	 $(SQLITE3_CFLAGS) \
	 $(LIBGCRYPT_CFLAGS)

PKGCFG_L=$(GLIB_LDFLAGS) \
	 $(SQLITE3_LDFLAGS) \
	 $(LIBGCRYPT_LDFLAGS)

HEADERS=-I$(AX_DIR)/src
CFLAGS += $(HEADERS) $(PKGCFG_C) -std=c11 -g -Wall -Wextra -Wpedantic \
		  -Wstrict-overflow -fno-strict-aliasing -funsigned-char \
		  -fno-builtin-memset
CPPFLAGS += -D_XOPEN_SOURCE=700 -D_BSD_SOURCE -D_POSIX_SOURCE -D_GNU_SOURCE -D_DEFAULT_SOURCE
TESTFLAGS=$(HEADERS) $(PKGCFG_C) -g -O0 --coverage
PICFLAGS=-fPIC $(CFLAGS)
LDFLAGS += -pthread -ldl $(PKGCFG_L) $(AX_PATH) -lm
LDFLAGS_T= -lcmocka $(LDFLAGS)

all: $(BDIR)/libaxc.a

$(BDIR):
	$(MKDIR_P) $@

client: $(SDIR)/message_client.c $(BDIR)/axc_store.o $(BDIR)/axc_crypto.o $(BDIR)/axc.o $(AX_PATH)
	$(MKDIR_P) $@
	$(CC) $(CPPFLAGS) $(CFLAGS) $^ -o $@/$@.o $(LDFLAGS)

$(BDIR)/axc.o: $(SDIR)/axc.c $(BDIR)
	$(CC) $(PICFLAGS) $(CPPFLAGS) -c $< -o $@

$(BDIR)/axc-nt.o: $(SDIR)/axc.c $(BDIR)
	$(CC) $(PICFLAGS) $(CPPFLAGS) -DNO_THREADS -c $< -o $@

$(BDIR)/axc_crypto.o: $(SDIR)/axc_crypto.c $(BDIR)
	$(CC) $(PICFLAGS) $(CPPFLAGS) -c $< -o $@

$(BDIR)/axc_store.o: $(SDIR)/axc_store.c $(BDIR)
	$(CC) $(PICFLAGS) $(CPPFLAGS) -c $< -o $@

$(BDIR)/libaxc.a: $(BDIR)/axc.o $(BDIR)/axc_crypto.o $(BDIR)/axc_store.o
	$(AR) rcs $@ $^

$(BDIR)/libaxc-nt.a: $(BDIR)/axc-nt.o $(BDIR)/axc_crypto.o $(BDIR)/axc_store.o
	$(AR) rcs $@ $^

$(AX_PATH):
	cd $(AX_DIR) && \
		$(MKDIR_P) build && \
		cd build && \
		$(CMAKE) $(CMAKE_FLAGS) ..  && \
		$(MAKE)

.PHONY: test
test: $(AX_PATH) test_store test_client

.PHONY: test_store
test_store: $(SDIR)/axc_store.c $(SDIR)/axc_crypto.c $(TDIR)/test_store.c
	$(CC) $(TESTFLAGS) -o $(TDIR)/$@.o  $(TDIR)/test_store.c $(SDIR)/axc_crypto.c $(LDFLAGS_T)
	-$(TDIR)/$@.o
	mv *.g* $(TDIR)

.PHONY: test_client
test_client: $(SDIR)/axc.c $(SDIR)/axc_crypto.c  $(SDIR)/axc_store.c $(TDIR)/test_client.c
	$(CC) $(TESTFLAGS) -g $(HEADERS) -o $(TDIR)/$@.o $(SDIR)/axc_crypto.c $(TDIR)/test_client.c $(LDFLAGS_T)
	-$(TDIR)/$@.o
	mv *.g* $(TDIR)

.PHONY: coverage
coverage: test
	gcovr -r . --html --html-details -o $@.html
	gcovr -r . -s
	$(MKDIR_P) $@
	mv $@.* $@

.PHONY: clean
clean:
	rm -f $(TDIR)/*.o
	rm -f $(TDIR)/*.gcno $(TDIR)/*.gcda $(TDIR)/*.sqlite
	
.PHONY: clean-all
clean-all: clean
	rm -rf client $(BDIR) $(CDIR) $(AX_DIR)/build

=== debian/changelog ===
axc (0.3.3-1) unstable; urgency=medium

  [ Henry-Nicolas Tourneur ]
  * Initial release. Closes: #926343

  [ Federico Ceratto ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Henry-Nicolas Tourneur <debian@nilux.be>  Mon, 27 Jul 2020 11:40:53 +0000

=== debian/control ===
Source: axc
Section: devel
Priority: optional
Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
Uploaders:
 Henry-Nicolas Tourneur <debian@nilux.be>,
Build-Depends:
 debhelper-compat (= 13),
 libcmocka-dev,
 libgcrypt20-dev,
 libglib2.0-dev,
 libsignal-protocol-c-dev,
 libsqlite3-dev,
 pkg-config,
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://github.com/gkdr/axc
Vcs-Git: https://salsa.debian.org/DebianOnMobile-team/libaxc.git
Vcs-Browser: https://salsa.debian.org/DebianOnMobile-team/libaxc

Package: libaxc0
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: client library for libsignal-protocol-c
 Client lib for libsignal-c, implementing the needed database and crypto
 interfaces using SQLite and gcrypt. Initially, the library's name was
 libaxolotl, hence the name.
 Additionally it provides utility functions for common use cases like encrypting
 and decrypting, ultimately making direct use of libsignal unnecessary.

Package: libaxc-dev
Section: libdevel
Architecture: any
Depends:
 libaxc0 (= ${binary:Version}),
 libsignal-protocol-c-dev,
 ${misc:Depends},
Description: development headers for libaxc
 Client library for libsignal-c, implementing the needed database and crypto
 interfaces using SQLite and gcrypt. Initially, the library's name was
 libaxolotl, hence the name.
 .
 Additionally it provides utility functions for common use cases like encrypting
 and decrypting, ultimately making direct use of libsignal unnecessary.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

# No setting build flag for hardening here since those are overwritten
# by the Makefile. The Makefile is patched instead.

export DEB_BUILD_MAINT_OPTIONS= hardening=+all
SOFILE=usr/lib/${DEB_HOST_MULTIARCH}/libaxc.so

%:
	dh $@

# Makefile is not generated so we need to explicitely set PREFIX variable
override_dh_auto_install:
	PREFIX=/usr dh_auto_install

override_dh_auto_build:
	PREFIX=/usr dh_auto_build

override_dh_link:
	dh_link -plibaxc0 ${SOFILE}.0.3.3 ${SOFILE}.0.3
	dh_link -plibaxc0 ${SOFILE}.0.3.3 ${SOFILE}.0
	dh_link -plibaxc-dev ${SOFILE}.0 ${SOFILE}

override_dh_auto_test:
	dh_auto_test -- -j1

## axc 0.3.7

=== Makefile ===
### toolchain
#
CC ?= gcc
AR ?= ar
MKDIR = mkdir
MKDIR_P = mkdir -p
CMAKE ?= cmake
CMAKE_FLAGS = -DCMAKE_BUILD_TYPE=Debug -DCMAKE_C_FLAGS=-fPIC
ARCH := $(shell $(CC) -print-multiarch)
VER_MAJ = 0
VERSION = 0.3.7

AX_DIR=./lib/libsignal-protocol-c
AX_BDIR=$(AX_DIR)/build
AX_PATH=$(AX_BDIR)/src/libsignal-protocol-c.a

PKG_CONFIG ?= pkg-config
GLIB_CFLAGS ?= $(shell $(PKG_CONFIG) --cflags glib-2.0)
GLIB_LDFLAGS ?= $(shell $(PKG_CONFIG) --libs glib-2.0)

SQLITE3_CFLAGS ?= $(shell $(PKG_CONFIG) --cflags sqlite3)
SQLITE3_LDFLAGS ?= $(shell $(PKG_CONFIG) --libs sqlite3)

SIGNAL_CFLAGS ?= $(shell $(PKG_CONFIG) --cflags libsignal-protocol-c)
SIGNAL_LDFLAGS ?= $(shell $(PKG_CONFIG) --libs libsignal-protocol-c)

LIBGCRYPT_CONFIG ?= libgcrypt-config
LIBGCRYPT_LDFLAGS ?= $(shell $(LIBGCRYPT_CONFIG) --libs)


SDIR = src
LDIR = lib
BDIR = build
TDIR = test
TFN = test_all
CDIR = coverage

PKGCFG_C=$(GLIB_CFLAGS) \
	 $(SQLITE3_CFLAGS) \
	 $(LIBGCRYPT_CFLAGS)

PKGCFG_L=$(GLIB_LDFLAGS) \
	 $(SQLITE3_LDFLAGS) \
	 $(LIBGCRYPT_LDFLAGS)

REQPKG=libsignal-protocol-c
REQPKG:=$(shell $(PKG_CONFIG) --exists $(REQPKG) && echo '$(REQPKG)')
ifneq ($(REQPKG),)
	AX_PATH_AS_NEEDED =
	PKGCFG_C += $(SIGNAL_CFLAGS)
	PKGCFG_L += $(SIGNAL_LDFLAGS)
else
	AX_PATH_AS_NEEDED = $(AX_PATH)
	HEADERS=-I$(AX_DIR)/src
	PKGCFG_C +=$(HEADERS)
	PKGCFG_L +=$(AX_PATH)
endif

ifeq ($(PREFIX),)
	PREFIX := /usr/local
endif

CPPFLAGS += -D_XOPEN_SOURCE=700 -D_BSD_SOURCE -D_POSIX_SOURCE -D_GNU_SOURCE -D_DEFAULT_SOURCE
CFLAGS += $(PKGCFG_C) -std=c11 -g -Wall -Wextra -Wpedantic \
	  -Wstrict-overflow -fno-strict-aliasing -funsigned-char \
	  -fno-builtin-memset -fstack-protector-strong -Wformat -Werror=format-security
TESTFLAGS=$(PKGCFG_C) -g -O0 --coverage -Wall -Wextra -Wpedantic -Wstrict-overflow -fstack-protector-strong -Wformat -Werror=format-security
LDFLAGS += -pthread -ldl $(PKGCFG_L) -lm
LDFLAGS_T= -lcmocka $(LDFLAGS)
PICFLAGS=-fPIC $(CFLAGS)


all: $(BDIR)/libaxc.a shared

$(BDIR):
	$(MKDIR_P) $@

client: $(SDIR)/message_client.c $(BDIR)/axc_store.o $(BDIR)/axc_crypto.o $(BDIR)/axc.o $(AX_PATH_AS_NEEDED)
	$(MKDIR_P) $@
	$(CC) $(CPPFLAGS) $(CFLAGS) $^ -o $@/$@.o $(LDFLAGS)

$(BDIR)/axc.o: $(SDIR)/axc.c $(AX_PATH_AS_NEEDED) | $(BDIR)
	$(CC) $(PICFLAGS) $(CPPFLAGS) -c $< -o $@

$(BDIR)/axc-nt.o: $(SDIR)/axc.c $(AX_PATH_AS_NEEDED) | $(BDIR)
	$(CC) $(PICFLAGS) $(CPPFLAGS) -DNO_THREADS -c $< -o $@

$(BDIR)/axc_crypto.o: $(SDIR)/axc_crypto.c $(AX_PATH_AS_NEEDED) | $(BDIR)
	$(CC) $(PICFLAGS) $(CPPFLAGS) -c $< -o $@

$(BDIR)/axc_store.o: $(SDIR)/axc_store.c $(AX_PATH_AS_NEEDED) | $(BDIR)
	$(CC) $(PICFLAGS) $(CPPFLAGS) -c $< -o $@

$(BDIR)/libaxc.a: $(BDIR)/axc.o $(BDIR)/axc_crypto.o $(BDIR)/axc_store.o
	$(AR) rcs $@ $^

$(BDIR)/libaxc-nt.a: $(BDIR)/axc-nt.o $(BDIR)/axc_crypto.o $(BDIR)/axc_store.o
	$(AR) rcs $@ $^

$(BDIR)/libaxc.so: $(AX_PATH_AS_NEEDED) | $(BDIR)
	$(CC) -shared -Wl,-soname,libaxc.so.$(VER_MAJ) -o $@ $(PICFLAGS) $(SDIR)/axc.c $(SDIR)/axc_crypto.c $(SDIR)/axc_store.c $(LDFLAGS) $(CPPFLAGS)

$(BDIR)/libaxc.pc: $(BDIR)
	echo 'prefix='$(PREFIX) > $@
	echo 'exec_prefix=$${prefix}' >> $@
	echo 'libdir=$${prefix}/lib/$(ARCH)' >> $@
	echo 'includedir=$${prefix}/include' >> $@
	echo 'Name: libaxc' >> $@
	echo 'Version: ${VERSION}' >> $@
	echo 'Description: client library for libsignal-protocol-c' >> $@
	echo 'Requires: libsignal-protocol-c' >> $@
	echo 'Cflags: -I$${includedir}/axc' >> $@
	echo 'Libs: -L$${libdir} -laxc' >> $@

$(AX_DIR):
	@echo "ERROR: Git submodules are not initialized, please run e.g. 'git submodule update --init --recursive' first" >&2 ; false

$(AX_BDIR): | $(AX_DIR)
	$(MKDIR_P) $@

$(AX_PATH): | $(AX_BDIR)
	cd $(AX_BDIR) && $(CMAKE) $(CMAKE_FLAGS) ..
	$(MAKE) -C $(AX_BDIR)

shared: $(BDIR)/libaxc.so $(BDIR)/libaxc.pc


install: $(BDIR)
	install -d $(DESTDIR)/$(PREFIX)/lib/$(ARCH)/pkgconfig/
	install -m 644 $(BDIR)/libaxc.a  $(DESTDIR)/$(PREFIX)/lib/$(ARCH)/libaxc.a
	install -m 644 $(BDIR)/libaxc.so $(DESTDIR)/$(PREFIX)/lib/$(ARCH)/libaxc.so.$(VERSION)
	ln -s libaxc.so.$(VERSION) $(DESTDIR)/$(PREFIX)/lib/$(ARCH)/libaxc.so.$(VER_MAJ)
	ln -s libaxc.so.$(VERSION) $(DESTDIR)/$(PREFIX)/lib/$(ARCH)/libaxc.so
	install -m 644 $(BDIR)/libaxc.pc $(DESTDIR)/$(PREFIX)/lib/$(ARCH)/pkgconfig/
	install -d $(DESTDIR)/$(PREFIX)/include/axc/
	install -m 644 $(SDIR)/axc.h $(DESTDIR)/$(PREFIX)/include/axc/
	install -m 644 $(SDIR)/axc_crypto.h $(DESTDIR)/$(PREFIX)/include/axc/
	install -m 644 $(SDIR)/axc_store.h $(DESTDIR)/$(PREFIX)/include/axc/


.PHONY: test
test: test_store test_client

.PHONY: test_store
test_store: $(SDIR)/axc_store.c $(SDIR)/axc_crypto.c $(TDIR)/test_store.c $(AX_PATH_AS_NEEDED)
	$(CC) $(TESTFLAGS) -o $(TDIR)/$@.o  $(TDIR)/test_store.c $(SDIR)/axc_crypto.c $(LDFLAGS_T)
	-$(TDIR)/$@.o
	find . -maxdepth 1 -iname 'test*.g*' -exec mv {} $(TDIR) \;

.PHONY: test_client
test_client: $(SDIR)/axc.c $(SDIR)/axc_crypto.c  $(SDIR)/axc_store.c $(TDIR)/test_client.c $(AX_PATH_AS_NEEDED)
	$(CC) $(TESTFLAGS) -o $(TDIR)/$@.o $(SDIR)/axc_crypto.c $(TDIR)/test_client.c $(LDFLAGS_T)
	-$(TDIR)/$@.o
	find . -maxdepth 1 -iname 'test*.g*' -exec mv {} $(TDIR) \;

.PHONY: coverage
coverage: test
	gcovr -r . --html --html-details -o $@.html
	gcovr -r . -s
	$(MKDIR_P) $@
	mv $@.* $@

.PHONY: clean
clean:
	rm -f $(TDIR)/*.o
	rm -f $(TDIR)/*.gcno $(TDIR)/*.gcda $(TDIR)/*.sqlite
	
.PHONY: clean-all
clean-all: clean
	rm -rf client $(BDIR) $(CDIR) $(AX_BDIR)

=== debian/changelog ===
axc (0.3.7-1) unstable; urgency=medium

  * New upstream version 0.3.7
  * d/patches: cleanup patches that are upstreamed

 -- Henry-Nicolas Tourneur <debian@nilux.be>  Mon, 31 Jan 2022 20:42:23 +0000

axc (0.3.6-2) unstable; urgency=medium

  * Fix FTCBFS: Consistently use the host architecture
    compiler. (Closes: #994671)

 -- Henry-Nicolas Tourneur <debian@nilux.be>  Sun, 19 Sep 2021 14:18:49 +0000

axc (0.3.6-1) unstable; urgency=medium

  * New upstream version 0.3.6
  * d/patches: remove upstreamed patches

 -- Henry-Nicolas Tourneur <debian@nilux.be>  Fri, 17 Sep 2021 15:55:04 +0000

axc (0.3.5-2) unstable; urgency=medium

  * d/patches: add 001_makefile-fix-ftcbfs.patch (Closes: #993455)

 -- Henry-Nicolas Tourneur <debian@nilux.be>  Wed, 01 Sep 2021 17:12:01 +0000

axc (0.3.5-1) unstable; urgency=medium

  * New upstream version 0.3.5
  * d/patches: remove upstreamed patches

 -- Henry-Nicolas Tourneur <debian@nilux.be>  Wed, 25 Aug 2021 09:39:51 +0000

axc (0.3.4-1) unstable; urgency=medium

  * New upstream version 0.3.4
  * d/salsa-ci.yml: disable aptly
  * d/patches: remove 001_fix_makefile.patch that has been upstreamed
  * d/patches: 001_makefile_fixtest-race.patch
    fixes a potential FTBFS (Closes: #983975)
  * Perform the sofile linking using upstream build infrastructure
  * Cleanup on d/rules: leftovers from unused patches
  * d/control: bump Standard-Version (no changes needed)

 -- Henry-Nicolas Tourneur <debian@nilux.be>  Sun, 15 Aug 2021 10:33:45 +0000

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
  libsignal-protocol-c-dev,
  libsqlite3-dev,
  pkg-config,
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: https://github.com/gkdr/axc
 Vcs-Git: https://salsa.debian.org/DebianOnMobile-team/libaxc.git

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/axc-$1\.tar\.gz/ \
  https://github.com/gkdr/axc/tags .*/v?(\d\S+)\.tar\.gz
